diff --git a/plugins/wobbly.c b/plugins/wobbly.c
index d05c983..1beacb0 100644
--- a/plugins/wobbly.c
+++ b/plugins/wobbly.c
@@ -161,6 +161,12 @@ typedef struct _WobblyScreen {
     unsigned int grabMask;
     CompWindow	 *grabWindow;
     Bool         moveWindow;
+
+    Model *model;
+    int   x;
+    int   y;
+    float width;
+    float height;
 } WobblyScreen;
 
 #define WobblyInitial  (1L << 0)
@@ -270,7 +276,7 @@ findNextWestEdge (CompWindow *w,
 
 	v1 = w->screen->outputDev[output].region.extents.x1;
 
-	for (p = w->screen->windows; p; p = p->next)
+	for (p = w->parent->windows; p; p = p->next)
 	{
 	    if (w == p)
 		continue;
@@ -375,7 +381,7 @@ findNextEastEdge (CompWindow *w,
 
 	v1 = w->screen->outputDev[output].region.extents.x2;
 
-	for (p = w->screen->windows; p; p = p->next)
+	for (p = w->parent->windows; p; p = p->next)
 	{
 	    if (w == p)
 		continue;
@@ -480,7 +486,7 @@ findNextNorthEdge (CompWindow *w,
 
 	v1 = w->screen->outputDev[output].region.extents.y1;
 
-	for (p = w->screen->windows; p; p = p->next)
+	for (p = w->parent->windows; p; p = p->next)
 	{
 	    if (w == p)
 		continue;
@@ -583,7 +589,7 @@ findNextSouthEdge (CompWindow *w,
 
 	v1 = w->screen->outputDev[output].region.extents.y2;
 
-	for (p = w->screen->windows; p; p = p->next)
+	for (p = w->parent->windows; p; p = p->next)
 	{
 	    if (w == p)
 		continue;
@@ -1656,7 +1662,8 @@ wobblyPreparePaintScreen (CompScreen *s,
 	springK  = ws->opt[WOBBLY_SCREEN_OPTION_SPRING_K].value.f;
 
 	ws->wobblyWindows = 0;
-	for (w = s->windows; w; w = w->next)
+
+	for (w = s->root.windows; w; w = walkDepthFirst (w))
 	{
 	    ww = GET_WOBBLY_WINDOW (w, ws);
 
@@ -1806,19 +1813,17 @@ wobblyAddWindowGeometry (CompWindow *w,
 			 Region     region,
 			 Region     clip)
 {
-    WOBBLY_WINDOW (w);
     WOBBLY_SCREEN (w->screen);
 
-    if (ww->wobbly)
+    if (ws->model)
     {
-	BoxPtr   pClip;
-	int      nClip, nVertices, nIndices;
+	BoxPtr   pClip, pBox;
+	int      nClip, nBox, nVertices, nIndices;
 	GLushort *i;
 	GLfloat  *v;
 	int      x1, y1, x2, y2;
-	float    width, height;
 	float    deformedX, deformedY;
-	int      x, y, iw, ih, wx, wy;
+	int      x, y, iw, ih;
 	int      vSize, it;
 	int      gridW, gridH;
 	Bool     rect = TRUE;
@@ -1832,21 +1837,16 @@ wobblyAddWindowGeometry (CompWindow *w,
 	    }
 	}
 
-	wx     = WIN_X (w);
-	wy     = WIN_Y (w);
-	width  = WIN_W (w);
-	height = WIN_H (w);
-
-	gridW = width / ws->opt[WOBBLY_SCREEN_OPTION_GRID_RESOLUTION].value.i;
+	gridW = ws->width / ws->opt[WOBBLY_SCREEN_OPTION_GRID_RESOLUTION].value.i;
 	if (gridW < ws->opt[WOBBLY_SCREEN_OPTION_MIN_GRID_SIZE].value.i)
 	    gridW = ws->opt[WOBBLY_SCREEN_OPTION_MIN_GRID_SIZE].value.i;
 
-	gridH = height / ws->opt[WOBBLY_SCREEN_OPTION_GRID_RESOLUTION].value.i;
+	gridH = ws->height / ws->opt[WOBBLY_SCREEN_OPTION_GRID_RESOLUTION].value.i;
 	if (gridH < ws->opt[WOBBLY_SCREEN_OPTION_MIN_GRID_SIZE].value.i)
 	    gridH = ws->opt[WOBBLY_SCREEN_OPTION_MIN_GRID_SIZE].value.i;
 
-	nClip = region->numRects;
-	pClip = region->rects;
+	nBox = region->numRects;
+	pBox = region->rects;
 
 	w->texUnits = nMatrix;
 
@@ -1858,96 +1858,117 @@ wobblyAddWindowGeometry (CompWindow *w,
 	v = w->vertices + (nVertices * vSize);
 	i = w->indices  + nIndices;
 
-	while (nClip--)
+	while (nBox--)
 	{
-	    x1 = pClip->x1;
-	    y1 = pClip->y1;
-	    x2 = pClip->x2;
-	    y2 = pClip->y2;
-
-	    iw = ((x2 - x1 - 1) / gridW) + 1;
-	    ih = ((y2 - y1 - 1) / gridH) + 1;
-
-	    if (nIndices + (iw * ih * 4) > w->indexSize)
-	    {
-		if (!moreWindowIndices (w, nIndices + (iw * ih * 4)))
-		    return;
-
-		i = w->indices + nIndices;
-	    }
-
-	    iw++;
-	    ih++;
+	    nClip = clip->numRects;
+	    pClip = clip->rects;
 
-	    for (y = 0; y < ih - 1; y++)
+	    while (nClip--)
 	    {
-		for (x = 0; x < iw - 1; x++)
+		x1 = pClip->x1;
+		y1 = pClip->y1;
+		x2 = pClip->x2;
+		y2 = pClip->y2;
+
+		if (x1 < pBox->x1)
+		    x1 = pBox->x1;
+		if (y1 < pBox->y1)
+		    y1 = pBox->y1;
+		if (x2 > pBox->x2)
+		    x2 = pBox->x2;
+		if (y2 > pBox->y2)
+		    y2 = pBox->y2;
+
+		if (x1 < x2 && y1 < y2)
 		{
-		    *i++ = nVertices + iw * (y + 1) + x;
-		    *i++ = nVertices + iw * (y + 1) + x + 1;
-		    *i++ = nVertices + iw * y + x + 1;
-		    *i++ = nVertices + iw * y + x;
-
-		    nIndices += 4;
-		}
-	    }
+		    iw = ((x2 - x1 - 1) / gridW) + 1;
+		    ih = ((y2 - y1 - 1) / gridH) + 1;
 
-	    if (((nVertices + iw * ih) * vSize) > w->vertexSize)
-	    {
-		if (!moreWindowVertices (w, (nVertices + iw * ih) * vSize))
-		    return;
-
-		v = w->vertices + (nVertices * vSize);
-	    }
-
-	    for (y = y1;; y += gridH)
-	    {
-		if (y > y2)
-		    y = y2;
+		    if (nIndices + (iw * ih * 4) > w->indexSize)
+		    {
+			if (!moreWindowIndices (w, nIndices + (iw * ih * 4)))
+			    return;
 
-		for (x = x1;; x += gridW)
-		{
-		    if (x > x2)
-			x = x2;
+			i = w->indices + nIndices;
+		    }
 
-		    bezierPatchEvaluate (ww->model,
-					 (x - wx) / width,
-					 (y - wy) / height,
-					 &deformedX,
-					 &deformedY);
+		    iw++;
+		    ih++;
 
-		    if (rect)
+		    for (y = 0; y < ih - 1; y++)
 		    {
-			for (it = 0; it < nMatrix; it++)
+			for (x = 0; x < iw - 1; x++)
 			{
-			    *v++ = COMP_TEX_COORD_X (&matrix[it], x);
-			    *v++ = COMP_TEX_COORD_Y (&matrix[it], y);
+			    *i++ = nVertices + iw * (y + 1) + x;
+			    *i++ = nVertices + iw * (y + 1) + x + 1;
+			    *i++ = nVertices + iw * y + x + 1;
+			    *i++ = nVertices + iw * y + x;
+
+			    nIndices += 4;
 			}
 		    }
-		    else
+
+		    if (((nVertices + iw * ih) * vSize) > w->vertexSize)
 		    {
-			for (it = 0; it < nMatrix; it++)
-			{
-			    *v++ = COMP_TEX_COORD_XY (&matrix[it], x, y);
-			    *v++ = COMP_TEX_COORD_YX (&matrix[it], x, y);
-			}
+			if (!moreWindowVertices (w,
+						 (nVertices + iw * ih) * vSize))
+			    return;
+
+			v = w->vertices + (nVertices * vSize);
 		    }
 
-		    *v++ = deformedX;
-		    *v++ = deformedY;
-		    *v++ = 0.0;
+		    for (y = y1;; y += gridH)
+		    {
+			if (y > y2)
+			    y = y2;
 
-		    nVertices++;
+			for (x = x1;; x += gridW)
+			{
+			    if (x > x2)
+				x = x2;
+
+			    bezierPatchEvaluate (ws->model,
+						 (x - ws->x) / ws->width,
+						 (y - ws->y) / ws->height,
+						 &deformedX,
+						 &deformedY);
+
+			    if (rect)
+			    {
+				for (it = 0; it < nMatrix; it++)
+				{
+				    *v++ = COMP_TEX_COORD_X (&matrix[it], x);
+				    *v++ = COMP_TEX_COORD_Y (&matrix[it], y);
+				}
+			    }
+			    else
+			    {
+				for (it = 0; it < nMatrix; it++)
+				{
+				    *v++ = COMP_TEX_COORD_XY (&matrix[it], x, y);
+				    *v++ = COMP_TEX_COORD_YX (&matrix[it], x, y);
+				}
+			    }
+
+			    *v++ = deformedX;
+			    *v++ = deformedY;
+			    *v++ = 0.0;
+
+			    nVertices++;
+
+			    if (x == x2)
+				break;
+			}
 
-		    if (x == x2)
-			break;
+			if (y == y2)
+			    break;
+		    }
 		}
-
-		if (y == y2)
-		    break;
+		
+		pClip++;
 	    }
 
-	    pClip++;
+	    pBox++;
 	}
 
 	w->vCount	      = nVertices;
@@ -1964,6 +1985,53 @@ wobblyAddWindowGeometry (CompWindow *w,
     }
 }
 
+static void
+wobblyDrawSubWindows (CompWindow          *w,
+		      const CompTransform *transform,
+		      Region              region,
+		      int                 mask)
+{
+    CompWindow *c;
+
+    for (c = w->windows; c; c = c->next)
+    {
+	FragmentAttrib fragment;
+	unsigned int   wMask = mask;
+
+	initFragmentAttrib (&fragment, &c->lastPaint);
+
+	if (c->alpha || fragment.opacity != OPAQUE)
+	    wMask |= PAINT_WINDOW_TRANSLUCENT_MASK;
+
+	(*w->screen->drawWindow) (c, transform, &fragment, region, wMask);
+
+	if (c->windows)
+	{
+	    Region r;
+
+	    r = XCreateRegion ();
+	    if (r)
+	    {
+		WOBBLY_SCREEN (w->screen);
+
+		XSubtractRegion (region, &emptyRegion, r);
+		XIntersectRegion (r, c->region, r);
+		XOffsetRegion (r, -c->attrib.x, -c->attrib.y);
+
+		ws->x -= c->attrib.x;
+		ws->y -= c->attrib.y;
+
+		wobblyDrawSubWindows (c, transform, r, mask);
+
+		ws->x += c->attrib.x;
+		ws->y += c->attrib.y;
+
+		XDestroyRegion (r);
+	    }
+	}
+    }
+}
+
 static Bool
 wobblyPaintWindow (CompWindow		   *w,
 		   const WindowPaintAttrib *attrib,
@@ -1971,17 +2039,69 @@ wobblyPaintWindow (CompWindow		   *w,
 		   Region		   region,
 		   unsigned int		   mask)
 {
-    Bool status;
+    CompScreen *s = w->screen;
+    Bool       status;
 
-    WOBBLY_SCREEN (w->screen);
+    WOBBLY_SCREEN (s);
     WOBBLY_WINDOW (w);
 
     if (ww->wobbly)
-	mask |= PAINT_WINDOW_TRANSFORMED_MASK;
+    {
+	FragmentAttrib fragment;
 
-    UNWRAP (ws, w->screen, paintWindow);
-    status = (*w->screen->paintWindow) (w, attrib, transform, region, mask);
-    WRAP (ws, w->screen, paintWindow, wobblyPaintWindow);
+	if (mask & PAINT_WINDOW_OCCLUSION_DETECTION_MASK)
+	    return FALSE;
+
+	UNWRAP (ws, s, paintWindow);
+	status = (*s->paintWindow) (w, attrib, transform, region,
+				    mask | PAINT_WINDOW_NO_CORE_INSTANCE_MASK);
+	WRAP (ws, s, paintWindow, wobblyPaintWindow);
+
+	glPushMatrix ();
+	glLoadMatrixf (transform->m);
+
+	ws->model  = ww->model;
+	ws->x      = WIN_X (w);
+	ws->y      = WIN_Y (w);
+	ws->width  = WIN_W (w);
+	ws->height = WIN_H (w);
+
+	initFragmentAttrib (&fragment, &w->lastPaint);
+
+	if (w->alpha || fragment.opacity != OPAQUE)
+	    mask |= PAINT_WINDOW_TRANSLUCENT_MASK;
+
+	(*s->drawWindow) (w,
+			  transform,
+			  &fragment,
+			  region,
+			  mask | PAINT_WINDOW_TRANSFORMED_MASK);
+
+	if (w->windows)
+	{
+	    XOffsetRegion (w->region, -w->attrib.x, -w->attrib.y);
+
+	    ws->x -= w->attrib.x;
+	    ws->y -= w->attrib.y;
+	    
+	    wobblyDrawSubWindows (w,
+				  transform,
+				  w->region,
+				  PAINT_WINDOW_ON_TRANSFORMED_SCREEN_MASK);
+
+	    XOffsetRegion (w->region, w->attrib.x, w->attrib.y);
+	}
+
+	ws->model = NULL;
+
+	glPopMatrix ();
+    }
+    else
+    {
+	UNWRAP (ws, s, paintWindow);
+	status = (*s->paintWindow) (w, attrib, transform, region, mask);
+	WRAP (ws, s, paintWindow, wobblyPaintWindow);
+    }
 
     return status;
 }
@@ -2000,7 +2120,7 @@ wobblyEnableSnapping (CompDisplay     *d,
 
     for (s = d->screens; s; s = s->next)
     {
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = walkDepthFirst (w))
 	{
 	    WOBBLY_WINDOW (w);
 
@@ -2031,7 +2151,7 @@ wobblyDisableSnapping (CompDisplay     *d,
 
     for (s = d->screens; s; s = s->next)
     {
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = walkDepthFirst (w))
 	{
 	    WOBBLY_WINDOW (w);
 
@@ -2678,7 +2798,8 @@ wobblyInitDisplay (CompPlugin  *p,
 {
     WobblyDisplay *wd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     wd = malloc (sizeof (WobblyDisplay));
@@ -2763,6 +2884,8 @@ wobblyInitScreen (CompPlugin *p,
     ws->grabWindow = NULL;
     ws->moveWindow = FALSE;
 
+    ws->model = NULL;
+
     WRAP (ws, s, preparePaintScreen, wobblyPreparePaintScreen);
     WRAP (ws, s, donePaintScreen, wobblyDonePaintScreen);
     WRAP (ws, s, paintOutput, wobblyPaintOutput);
diff --git a/plugins/zoom.c b/plugins/zoom.c
index 8996c1c..4c3b881 100644
--- a/plugins/zoom.c
+++ b/plugins/zoom.c
@@ -163,7 +163,7 @@ zoomInEvent (CompScreen *s)
 
     o[0].type    = CompOptionTypeInt;
     o[0].name    = "root";
-    o[0].value.i = s->root;
+    o[0].value.i = s->root.id;
 
     o[1].type    = CompOptionTypeInt;
     o[1].name    = "output";
@@ -197,7 +197,7 @@ zoomOutEvent (CompScreen *s)
 
     o[0].type    = CompOptionTypeInt;
     o[0].name    = "root";
-    o[0].value.i = s->root;
+    o[0].value.i = s->root.id;
 
     o[1].type    = CompOptionTypeInt;
     o[1].name    = "output";
@@ -694,7 +694,7 @@ zoomTerminate (CompDisplay     *d,
     {
 	ZOOM_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (zs->grab)
@@ -719,7 +719,7 @@ zoomTerminate (CompDisplay     *d,
 
 	    o.type    = CompOptionTypeInt;
 	    o.name    = "root";
-	    o.value.i = s->root;
+	    o.value.i = s->root.id;
 
 	    zoomOut (d, action, state, &o, 1);
 	}
@@ -787,7 +787,7 @@ zoomTerminatePan (CompDisplay     *d,
     {
 	ZOOM_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (zs->panGrabIndex)
@@ -970,7 +970,8 @@ zoomInitDisplay (CompPlugin  *p,
 {
     ZoomDisplay *zd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     zd = malloc (sizeof (ZoomDisplay));
diff --git a/src/display.c b/src/display.c
index 23b0ba1..72515b6 100644
--- a/src/display.c
+++ b/src/display.c
@@ -195,8 +195,8 @@ mainMenu (CompDisplay     *d,
 
     s = findScreenAtDisplay (d, xid);
     if (s && !s->maxGrab)
-	toolkitAction (s, s->display->toolkitActionMainMenuAtom, time, s->root,
-		       0, 0, 0);
+	toolkitAction (s, s->display->toolkitActionMainMenuAtom, time,
+		       s->root.id, 0, 0, 0);
 
     return TRUE;
 }
@@ -217,8 +217,8 @@ runDialog (CompDisplay     *d,
 
     s = findScreenAtDisplay (d, xid);
     if (s && !s->maxGrab)
-	toolkitAction (s, s->display->toolkitActionRunDialogAtom, time, s->root,
-		       0, 0, 0);
+	toolkitAction (s, s->display->toolkitActionRunDialogAtom, time,
+		       s->root.id, 0, 0, 0);
 
     return TRUE;
 }
@@ -725,7 +725,7 @@ pingTimeout (void *closure)
 
     for (s = d->screens; s; s = s->next)
     {
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	{
 	    if (w->attrib.map_state != IsViewable)
 		continue;
@@ -841,7 +841,7 @@ setDisplayOption (CompPlugin	  *plugin,
     return FALSE;
 }
 
-static void
+void
 updatePlugins (CompDisplay *d)
 {
     CompOption *o;
@@ -1349,7 +1349,7 @@ doPoll (int timeout)
     return rv;
 }
 
-static void
+void
 handleTimeouts (struct timeval *tv)
 {
     CompTimeout *t;
@@ -1545,13 +1545,20 @@ eventLoop (void)
 	{
 	    for (s = d->screens; s; s = s->next)
 	    {
-		if (s->damageMask)
+		if (manualCompositeManagement)
 		{
-		    finishScreenDrawing (s);
+		    if (s->damageMask)
+		    {
+			finishScreenDrawing (s);
+		    }
+		    else
+		    {
+			s->idle = TRUE;
+		    }
 		}
 		else
 		{
-		    s->idle = TRUE;
+		    s->damageMask = 0;
 		}
 	    }
 	}
@@ -1624,7 +1631,7 @@ eventLoop (void)
 			/* substract top most overlay window region */
 			if (s->overlayWindowCount)
 			{
-			    for (w = s->reverseWindows; w; w = w->prev)
+			    for (w = s->root.reverseWindows; w; w = w->prev)
 			    {
 				if (w->destroyed || w->invisible)
 				    continue;
@@ -1748,24 +1755,6 @@ eventLoop (void)
 
 			(*s->donePaintScreen) (s);
 
-			/* remove destroyed windows */
-			while (s->pendingDestroys)
-			{
-			    CompWindow *w;
-
-			    for (w = s->windows; w; w = w->next)
-			    {
-				if (w->destroyed)
-				{
-				    addWindowDamage (w);
-				    removeWindow (w);
-				    break;
-				}
-			    }
-
-			    s->pendingDestroys--;
-			}
-
 			s->idle = FALSE;
 		    }
 		}
@@ -1797,6 +1786,38 @@ eventLoop (void)
 		doPoll (-1);
 	    }
 	}
+
+	for (d = core.displays; d; d = d->next)
+	{
+	    for (s = d->screens; s; s = s->next)
+	    {
+		/* remove destroyed windows */
+		while (s->pendingDestroys)
+		{
+		    CompWindow *w, *c;
+
+		    for (w = s->root.windows; w; w = walkDepthFirst (w))
+		    {
+			if (w->destroyed)
+			{
+                            for (c = w->windows;
+                                 c && c != w;
+                                 c = walkDepthFirst (c))
+                            {
+                                if (c->destroyed)
+                                    s->pendingDestroys--;
+                            }
+
+			    addWindowDamage (w);
+			    removeWindow (w);
+			    break;
+			}
+		    }
+
+		    s->pendingDestroys--;
+		}
+	    }
+	}
     }
 
     for (d = core.displays; d; d = d->next)
@@ -1864,7 +1885,8 @@ compCheckForError (Display *dpy)
 static void
 addScreenActions (CompScreen *s)
 {
-    int i;
+    CompPlugin *p;
+    int        i;
 
     for (i = 0; i < COMP_DISPLAY_OPTION_NUM; i++)
     {
@@ -1874,6 +1896,27 @@ addScreenActions (CompScreen *s)
 	if (s->display->opt[i].value.action.state & CompActionStateAutoGrab)
 	    addScreenAction (s, &s->display->opt[i].value.action);
     }
+
+    for (p = getPlugins (); p; p = p->next)
+    {
+	CompOption *option;
+	int	   nOption;
+
+	if (!p->vTable->getObjectOptions)
+	    continue;
+
+	option = (*p->vTable->getObjectOptions) (p,
+						 &s->display->base,
+						 &nOption);
+	for (i = 0; i < nOption; i++)
+	{
+	    if (!isActionOption (&option[i]))
+		continue;
+
+	    if (option[i].value.action.state & CompActionStateAutoGrab)
+		addScreenAction (s, &option[i].value.action);
+	}
+    }
 }
 
 void
@@ -1920,12 +1963,10 @@ addDisplay (const char *name)
     CompDisplay *d;
     CompPrivate	*privates;
     Display     *dpy;
-    Window	focus;
-    int		revertTo, i;
     int		compositeMajor, compositeMinor;
     int		fixesMinor;
     int		xkbOpcode;
-    int		firstScreen, lastScreen;
+    int		i;
 
     d = malloc (sizeof (CompDisplay));
     if (!d)
@@ -2198,6 +2239,8 @@ addDisplay (const char *name)
 
     d->startupIdAtom = XInternAtom (dpy, "_NET_STARTUP_ID", 0);
 
+    d->syncStateAtom = XInternAtom (dpy, "_COMPIZ_SYNC_STATE", 0);
+
     d->snDisplay = sn_display_new (dpy, NULL, NULL);
     if (!d->snDisplay)
 	return FALSE;
@@ -2288,7 +2331,7 @@ addDisplay (const char *name)
 						   &d->xineramaEvent,
 						   &d->xineramaError);
 
-    if (d->xineramaExtension)
+    if (d->xineramaExtension && XineramaIsActive (dpy))
 	d->screenInfo = XineramaQueryScreens (dpy, &d->nScreenInfo);
 
     d->escapeKeyCode = XKeysymToKeycode (dpy, XStringToKeysym ("Escape"));
@@ -2301,6 +2344,49 @@ addDisplay (const char *name)
 
     (*core.objectAdd) (&core.base, &d->base);
 
+    return TRUE;
+}
+
+void
+removeDisplay (CompDisplay *d)
+{
+    CompDisplay *p;
+
+    for (p = core.displays; p; p = p->next)
+	if (p->next == d)
+	    break;
+
+    if (p)
+	p->next = d->next;
+    else
+	core.displays = NULL;
+
+    while (d->screens)
+	removeScreen (d->screens);
+
+    (*core.objectRemove) (&core.base, &d->base);
+
+    objectFiniPlugins (&d->base);
+
+    compRemoveTimeout (d->pingHandle);
+
+    if (d->snDisplay)
+	sn_display_unref (d->snDisplay);
+
+    XSync (d->display, False);
+    XCloseDisplay (d->display);
+
+    freeDisplay (d);
+}
+
+Bool
+manageDisplay (CompDisplay *d)
+{
+    Display *dpy = d->display;
+    Window  focus;
+    int     revertTo, i;
+    int     firstScreen, lastScreen;
+
     if (onlyCurrentScreen)
     {
 	firstScreen = DefaultScreen (dpy);
@@ -2319,7 +2405,7 @@ addDisplay (const char *name)
 	Time		     wmSnTimestamp = 0;
 	XEvent		     event;
 	XSetWindowAttributes attr;
-	Window		     currentWmSnOwner, currentCmSnOwner;
+	Window		     currentWmSnOwner = None, currentCmSnOwner;
 	char		     buf[128];
 	Window		     rootDummy, childDummy;
 	unsigned int	     uDummy;
@@ -2328,7 +2414,8 @@ addDisplay (const char *name)
 	sprintf (buf, "WM_S%d", i);
 	wmSnAtom = XInternAtom (dpy, buf, 0);
 
-	currentWmSnOwner = XGetSelectionOwner (dpy, wmSnAtom);
+	if (windowManagement)
+	    currentWmSnOwner = XGetSelectionOwner (dpy, wmSnAtom);
 
 	if (currentWmSnOwner != None)
 	{
@@ -2366,6 +2453,9 @@ addDisplay (const char *name)
 
 		continue;
 	    }
+
+	    XSelectInput (dpy, currentCmSnOwner,
+			  StructureNotifyMask);
 	}
 
 	attr.override_redirect = TRUE;
@@ -2394,36 +2484,60 @@ addDisplay (const char *name)
 
 	wmSnTimestamp = event.xproperty.time;
 
-	XSetSelectionOwner (dpy, wmSnAtom, newWmSnOwner, wmSnTimestamp);
+	XSetSelectionOwner (dpy, cmSnAtom, newCmSnOwner, wmSnTimestamp);
 
-	if (XGetSelectionOwner (dpy, wmSnAtom) != newWmSnOwner)
+	if (XGetSelectionOwner (dpy, cmSnAtom) != newCmSnOwner)
 	{
 	    compLogMessage ("core", CompLogLevelError,
-			    "Could not acquire window manager "
+			    "Could not acquire compositing manager "
 			    "selection on screen %d display \"%s\"",
 			    i, DisplayString (dpy));
 
-	    XDestroyWindow (dpy, newWmSnOwner);
-
 	    continue;
 	}
 
-	/* Send client message indicating that we are now the WM */
-	event.xclient.type	   = ClientMessage;
-	event.xclient.window       = XRootWindow (dpy, i);
-	event.xclient.message_type = d->managerAtom;
-	event.xclient.format       = 32;
-	event.xclient.data.l[0]    = wmSnTimestamp;
-	event.xclient.data.l[1]    = wmSnAtom;
-	event.xclient.data.l[2]    = 0;
-	event.xclient.data.l[3]    = 0;
-	event.xclient.data.l[4]    = 0;
+	if (windowManagement)
+	{
+	    XSetSelectionOwner (dpy, wmSnAtom, newWmSnOwner, wmSnTimestamp);
+
+	    if (XGetSelectionOwner (dpy, wmSnAtom) != newWmSnOwner)
+	    {
+		compLogMessage ("core", CompLogLevelError,
+				"Could not acquire window manager "
+				"selection on screen %d display \"%s\"",
+				i, DisplayString (dpy));
+
+		XDestroyWindow (dpy, newWmSnOwner);
+
+		continue;
+	    }
 
-	XSendEvent (dpy, XRootWindow (dpy, i), FALSE,
-		    StructureNotifyMask, &event);
+	    /* Send client message indicating that we are now the WM */
+	    event.xclient.type	       = ClientMessage;
+	    event.xclient.window       = XRootWindow (dpy, i);
+	    event.xclient.message_type = d->managerAtom;
+	    event.xclient.format       = 32;
+	    event.xclient.data.l[0]    = wmSnTimestamp;
+	    event.xclient.data.l[1]    = wmSnAtom;
+	    event.xclient.data.l[2]    = 0;
+	    event.xclient.data.l[3]    = 0;
+	    event.xclient.data.l[4]    = 0;
+
+	    XSendEvent (dpy, XRootWindow (dpy, i), FALSE,
+			StructureNotifyMask, &event);
+	}
+
+	/* Wait for old compositing manager to go away */
+	if (currentCmSnOwner != None)
+	{
+	    do {
+		XWindowEvent (dpy, currentCmSnOwner,
+			      StructureNotifyMask, &event);
+	    } while (event.type != DestroyNotify);
+	}
 
 	/* Wait for old window manager to go away */
-	if (currentWmSnOwner != None)
+	if (currentWmSnOwner != None && currentCmSnOwner != currentWmSnOwner)
 	{
 	    do {
 		XWindowEvent (dpy, currentWmSnOwner,
@@ -2433,54 +2547,59 @@ addDisplay (const char *name)
 
 	compCheckForError (dpy);
 
-	XCompositeRedirectSubwindows (dpy, XRootWindow (dpy, i),
-				      CompositeRedirectManual);
-
-	if (compCheckForError (dpy))
+	if (manualCompositeManagement)
 	{
-	    compLogMessage ("core", CompLogLevelError,
-			    "Another composite manager is already "
-			    "running on screen: %d", i);
-
-	    continue;
-	}
+	    XCompositeRedirectSubwindows (dpy, XRootWindow (dpy, i),
+					  CompositeRedirectManual);
 
-	XSetSelectionOwner (dpy, cmSnAtom, newCmSnOwner, wmSnTimestamp);
+	    if (compCheckForError (dpy))
+	    {
+		compLogMessage ("core", CompLogLevelError,
+				"Another composite manager is already "
+				"running on screen: %d", i);
 
-	if (XGetSelectionOwner (dpy, cmSnAtom) != newCmSnOwner)
+		continue;
+	    }
+	}
+	else
 	{
-	    compLogMessage ("core", CompLogLevelError,
-			    "Could not acquire compositing manager "
-			    "selection on screen %d display \"%s\"",
-			    i, DisplayString (dpy));
-
-	    continue;
+	    XCompositeRedirectSubwindows (dpy, XRootWindow (dpy, i),
+					  CompositeRedirectAutomatic);
 	}
 
 	XGrabServer (dpy);
 
-	XSelectInput (dpy, XRootWindow (dpy, i),
-		      SubstructureRedirectMask |
-		      SubstructureNotifyMask   |
-		      StructureNotifyMask      |
-		      PropertyChangeMask       |
-		      LeaveWindowMask	       |
-		      EnterWindowMask	       |
-		      KeyPressMask	       |
-		      KeyReleaseMask	       |
-		      ButtonPressMask	       |
-		      ButtonReleaseMask	       |
-		      FocusChangeMask	       |
-		      ExposureMask);
-
-	if (compCheckForError (dpy))
+	if (windowManagement)
 	{
-	    compLogMessage ("core", CompLogLevelError,
-			    "Another window manager is "
-			    "already running on screen: %d", i);
+	    XSelectInput (dpy, XRootWindow (dpy, i),
+			  SubstructureRedirectMask |
+			  StructureNotifyMask      |
+			  PropertyChangeMask       |
+			  LeaveWindowMask          |
+			  EnterWindowMask          |
+			  KeyPressMask             |
+			  KeyReleaseMask           |
+			  ButtonPressMask          |
+			  ButtonReleaseMask        |
+			  FocusChangeMask          |
+			  ExposureMask);
+   
+	    if (compCheckForError (dpy))
+	    {
+		compLogMessage ("core", CompLogLevelError,
+				"Another window manager is "
+				"already running on screen: %d", i);
 
-	    XUngrabServer (dpy);
-	    continue;
+		XUngrabServer (dpy);
+		continue;
+	    }
+	}
+	else
+	{
+	    XSelectInput (dpy, XRootWindow (dpy, i),
+			  StructureNotifyMask      |
+			  PropertyChangeMask       |
+			  ExposureMask);
 	}
 
 	if (!addScreen (d, i, newWmSnOwner, wmSnAtom, wmSnTimestamp))
@@ -2503,74 +2622,50 @@ addDisplay (const char *name)
     if (!d->screens)
     {
 	compLogMessage ("core", CompLogLevelFatal,
-			"No manageable screens found on display %s",
-			XDisplayName (name));
+			"No manageable screens found on display");
 	return FALSE;
     }
 
     setAudibleBell (d, d->opt[COMP_DISPLAY_OPTION_AUDIBLE_BELL].value.b);
 
-    XGetInputFocus (dpy, &focus, &revertTo);
-
-    /* move input focus to root window so that we get a FocusIn event when
-       moving it to the default window */
-    XSetInputFocus (dpy, d->screens->root, RevertToPointerRoot, CurrentTime);
-
-    if (focus == None || focus == PointerRoot)
+    if (windowManagement)
     {
-	focusDefaultWindow (d->screens);
-    }
-    else
-    {
-	CompWindow *w;
+	XGetInputFocus (dpy, &focus, &revertTo);
 
-	w = findWindowAtDisplay (d, focus);
-	if (w)
+	/* move input focus to root window so that we get a FocusIn event when
+	   moving it to the default window */
+	XSetInputFocus (dpy, d->screens->root.id, RevertToPointerRoot,
+			CurrentTime);
+
+	if (focus == None || focus == PointerRoot)
 	{
-	    moveInputFocusToWindow (w);
+	    focusDefaultWindow (d->screens);
 	}
 	else
-	    focusDefaultWindow (d->screens);
-    }
-
-    d->pingHandle =
-	compAddTimeout (d->opt[COMP_DISPLAY_OPTION_PING_DELAY].value.i,
-			d->opt[COMP_DISPLAY_OPTION_PING_DELAY].value.i + 500,
-			pingTimeout, d);
-
-    return TRUE;
-}
-
-void
-removeDisplay (CompDisplay *d)
-{
-    CompDisplay *p;
+	{
+	    CompWindow *w;
 
-    for (p = core.displays; p; p = p->next)
-	if (p->next == d)
-	    break;
+	    w = findWindowAtDisplay (d, focus);
+	    if (w)
+	    {
+		moveInputFocusToWindow (w);
+	    }
+	    else
+		focusDefaultWindow (d->screens);
+	}
 
-    if (p)
-	p->next = d->next;
+	d->pingHandle =
+	    compAddTimeout (d->opt[COMP_DISPLAY_OPTION_PING_DELAY].value.i,
+			    d->opt[COMP_DISPLAY_OPTION_PING_DELAY].value.i +
+			    500, pingTimeout, d);
+    }
     else
-	core.displays = NULL;
-
-    while (d->screens)
-	removeScreen (d->screens);
-
-    (*core.objectRemove) (&core.base, &d->base);
-
-    objectFiniPlugins (&d->base);
-
-    compRemoveTimeout (d->pingHandle);
-
-    if (d->snDisplay)
-	sn_display_unref (d->snDisplay);
-
-    XSync (d->display, False);
-    XCloseDisplay (d->display);
+    {
+	d->activeWindow = d->screens->root.activeChild =
+	    getActiveWindow (d, d->screens->root.id);
+    }
 
-    freeDisplay (d);
+    return TRUE;
 }
 
 Time
@@ -2596,7 +2691,7 @@ findScreenAtDisplay (CompDisplay *d,
 
     for (s = d->screens; s; s = s->next)
     {
-	if (s->root == root)
+	if (s->root.id == root)
 	    return s;
     }
 
@@ -2632,6 +2727,23 @@ findWindowAtDisplay (CompDisplay *d,
 }
 
 CompWindow *
+findClientWindowAtDisplay (CompDisplay *d,
+			   Window      id)
+{
+    CompScreen *s;
+    CompWindow *w;
+
+    for (s = d->screens; s; s = s->next)
+    {
+	w = findClientWindowAtScreen (s, id);
+	if (w)
+	    return w;
+    }
+
+    return 0;
+}
+
+CompWindow *
 findTopLevelWindowAtDisplay (CompDisplay *d,
 			     Window      id)
 {
@@ -2823,7 +2935,7 @@ warpPointer (CompScreen *s,
 	pointerY = 0;
 
     XWarpPointer (display->display,
-		  None, s->root,
+		  None, s->root.id,
 		  0, 0, 0, 0,
 		  pointerX, pointerY);
 
